package com.sd.business.service.order.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.order.dto.OrderInfoDto;
import com.sd.business.entity.order.dto.OrderSelectDto;
import com.sd.business.entity.order.po.OrderInfo;
import com.sd.business.entity.order.vo.OrderInfoVo;
import com.sd.business.mapper.order.OrderMapper;
import com.sd.business.service.order.OrderService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 订单 服务实现类
 * </p>
 *
 * @author
 * @since 2023-06-30
 */
@Service
public class OrderServiceImpl extends ServiceImpl<OrderMapper, OrderInfo> implements OrderService {

    @Override
    public List<OrderInfoVo> getList(OrderSelectDto dto) {
        IWrapper<OrderInfo> wrapper = getWrapper();
        wrapper.orderByDesc("o", OrderInfo::getId);
        List<OrderInfoVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<OrderInfoVo> getPage(OrderSelectDto dto) {
        IWrapper<OrderInfo> wrapper = getWrapper();
        wrapper.orderByDesc("o", OrderInfo::getId);
        Page<OrderInfoVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public OrderInfoVo detail(Long id) {
        OrderInfo OrderInfo = this.getById(id);
        OrderInfoVo result = BeanUtil.toBean(OrderInfo, OrderInfoVo.class);
        return result;
    }

    @Override
    public void add(OrderInfoDto orderDto) {
        this.save(orderDto);
    }

    @Override
    public void edit(OrderInfoDto orderDto) {
        this.updateById(orderDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
