package com.sd.business.service.order.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.order.dto.OrderSkuDto;
import com.sd.business.entity.order.dto.OrderSkuSelectDto;
import com.sd.business.entity.order.po.OrderSku;
import com.sd.business.entity.order.vo.OrderSkuVo;
import com.sd.business.mapper.order.OrderSkuMapper;
import com.sd.business.service.order.OrderSkuService;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 订单sku 服务实现类
 * </p>
 *
 * @author
 * @since 2023-07-06
 */
@Service
public class OrderSkuServiceImpl extends ServiceImpl<OrderSkuMapper, OrderSku> implements OrderSkuService {

    @Override
    public Page<OrderSkuVo> getPage(OrderSkuSelectDto dto) {
        IWrapper<OrderSku> wrapper = getWrapper();
        wrapper.orderByDesc("os", OrderSku::getId);
        Page<OrderSkuVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public OrderSkuVo detail(Long id) {
        OrderSku OrderSku = this.getById(id);
        OrderSkuVo result = BeanUtil.toBean(OrderSku, OrderSkuVo.class);
        return result;
    }

    @Override
    public void add(OrderSkuDto orderSkuDto) {
        this.save(orderSkuDto);
    }

    @Override
    public void edit(OrderSkuDto orderSkuDto) {
        this.updateById(orderSkuDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
